# -*- coding: utf-8 -*-

"""
 (c) 2019 - Copyright Red Hat Inc

 Authors:
   Pierre-Yves Chibon <pingou@pingoured.fr>
   Karsten Hopp <karsten@redhat.com>

"""

from __future__ import print_function, unicode_literals

import pagure.forms

import wtforms


class AnityaForm(pagure.forms.PagureForm):
    """Form to configure taiga for a project."""

    anitya_status = wtforms.SelectField(
        "Monitoring status of the package in anitya",
        [wtforms.validators.DataRequired()],
        choices=[
            ("monitoring", "monitoring"),
            ("no-monitoring", "no-monitoring"),
            ("monitoring-with-scratch", "monitoring-with-scratch"),
            ("monitoring-all", "monitoring-all"),
            ("monitoring-all-scratch", "monitoring-all-scratch"),
            ("monitoring-stable", "monitoring-stable"),
            ("monitoring-stable-scratch", "monitoring-stable-scratch"),
        ],
    )


class OrphanReasonForm(pagure.forms.PagureForm):
    """Form for orphaning reason."""

    orphan_reason = wtforms.SelectField(
        "Reason for orphaning package",
        [wtforms.validators.optional(strip_whitespace=True)],
        choices=[
            ("Lack of time", "Lack of time"),
            ("Do not use it anymore", "Do not use it anymore"),
            ("Unmaintained upstream", "Unmaintained upstream"),
            ("Fails to build from source", "Fails to build from source"),
            ("Important bug not fixed", "Important bug not fixed"),
            ("Orphaned by releng", "Orphaned by releng"),
            ("Other", "Other"),
        ],
    )

    orphan_reason_info = wtforms.StringField(
        "Additional info",
        [wtforms.validators.optional(strip_whitespace=True)],
    )


class BZOverrideForm(pagure.forms.PagureForm):
    """Form to configure the Fedora/EPEL maintainer for a project."""

    fedora_assignee = wtforms.StringField(
        "Maintainer name", [wtforms.validators.optional(strip_whitespace=True)]
    )
    epel_assignee = wtforms.StringField(
        "EPEL Maintainer name",
        [wtforms.validators.optional(strip_whitespace=True)],
    )
